## qemu-linaro 0.15.50-2011.08

=== debian/changelog ===
qemu-linaro (0.15.50-2011.08-0ubuntu4) oneiric; urgency=low

  * FFe for new upstream version, fixing build failure in oneiric.
    LP: #832830.
  * debian/binfmts/*: replace unsupported 'flags: OC' with 'credentials yes',
    so that suid binaries work under qemu-user.  LP: #790971
  * debian/binfmts/qemu-armeb: point to qemu-armeb-static, not
    qemu-arm-static.  LP: #855365.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 26 Sep 2011 15:07:14 -0700

qemu-linaro (0.15.50-2011.08-0ubuntu3) oneiric; urgency=low

  * debian/patches/0001-tcg-ppc-tcg-target.c-Avoid-set-but-not-used-gcc-
    warn.patch: updated patch to fix additional warnings.
  * debian/patches/Reorder-default-ram_size-initialization.patch: patch from
    trunk, reorder default ram_size initialization, fixing a regression that
    slows down tcg-based system targets by a factor of 3-4.  Thanks to
    Jan Kiszka <jan.kiszka@web.de>.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 26 Aug 2011 17:00:24 -0700

qemu-linaro (0.15.50-2011.08-0ubuntu2) oneiric; urgency=low

  * debian/patches/6-6-tcg-arm-Make-tcg_out_addi-inline.patch: [6/6]
    tcg-arm: Make tcg_out_addi inline.  Fixes a build failure on armel.
  * debian/patches/5-6-tcg-ia64-Fix-typos-in-AREG0-setup-in-
    prologue..patch: [5/6] tcg-ia64: Fix typos in AREG0 setup in
    prologue.  Fixes a build failure on ia64.
  * debian/patches/0001-tcg-ppc-tcg-target.c-Avoid-set-but-not-used-gcc-
    warn.patch: Avoid 'set but not used' gcc warnings.  Fixes a build failure
    on powerpc.  Thanks to Peter Maydell <peter.maydell@linaro.org>.
  * debian/patches/target-cris-opcode-cris.h-rename-REG_PC-SP-to-
    CRIS_REG_PC-SP.patch: target-cris/opcode-cris.h: rename REG_PC/SP to
    CRIS_REG_PC/SP.  Fixes a build failure on sparc.  Thanks to
    Peter Maydell <peter.maydell@linaro.org>.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 19 Aug 2011 21:55:42 -0700

qemu-linaro (0.15.50-2011.08-0ubuntu1) oneiric; urgency=low

  * New upstream release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 19 Aug 2011 14:39:14 -0700

qemu-linaro (0.14.50-2011.06-0-0ubuntu1) oneiric; urgency=low

  * New upstream release.
  * debian/rules: drop workaround forcing building with -marm for
    armel/armhf, upstream code is now reported to work in Thumb-2 mode.
    LP: #731095.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 16 Jun 2011 09:04:43 -0700

qemu-linaro (0.14.50-2011.04-1-0ubuntu2) oneiric; urgency=low

  * Rework conffile removal:
    - use old style conffile removal as to not require a pre-depends on dpkg
      helpers which aren't present in lucid instead of using
      dpkg-maintscript-helper.
    - remove the conffile in qemu-user-static.preinst rather than
      qemu-kvm-extras-static.preinst, .postinst and .postrm as to leave no
      chance to the conffile to stay behind.

 -- Loïc Minier <loic.minier@linaro.org>  Wed, 18 May 2011 18:45:12 +0200

qemu-linaro (0.14.50-2011.04-1-0ubuntu1) oneiric; urgency=low

  * New upstream release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 04 May 2011 09:19:47 -0700

=== debian/control ===
Source: qemu-linaro
Section: misc
Priority: optional
DM-Upload-Allowed: yes
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>, Riku Voipio <riku.voipio@iki.fi>, Vagrant Cascadian <vagrant@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
               zlib1g-dev,
               libasound2-dev [!kfreebsd-any],
               libsdl1.2-dev (>> 1.2.1),
               libx11-dev,
               libpulse-dev,
               libncurses5-dev,
               libbrlapi-dev,
               libcurl4-gnutls-dev,
               libgnutls-dev,
               libsasl2-dev,
               uuid-dev,
               libvdeplug2-dev [!kfreebsd-any],
               libbluetooth-dev [!kfreebsd-any],
               texinfo,
               perl
Build-Conflicts: oss4-dev
Standards-Version: 3.9.1
Homepage: https://launchpad.net/qemu-linaro/
Vcs-Bzr: lp:ubuntu/qemu-linaro

Package: qemu-keymaps
Architecture: all
Depends: ${misc:Depends}
Breaks: qemu (<< 0.11.0-2), qemu-system (<< 0.12.4+dfsg-4)
Replaces: qemu (<< 0.11.0-2), qemu-system (<< 0.12.4+dfsg-4)
Description: QEMU keyboard maps
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides keyboard maps to be used by the qemu-system
 package or QEMU derivatives.

Package: qemu-system
Architecture: amd64 arm armel armhf hppa i386 ia64 mips mipsel powerpc sparc sparc64 kfreebsd-i386 kfreebsd-amd64 ppc64
Depends: ${shlibs:Depends}, ${misc:Depends}, qemu-keymaps (>= ${source:Version}), qemu-common
Recommends: vde2, qemu-kvm
Breaks: qemu (<< 0.11.0-2), qemu-kvm-extras (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Replaces: qemu (<< 0.11.0-2), qemu-kvm-extras (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Suggests: samba
Description: QEMU full system emulation binaries
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries for targets other
 than x86 and x86-64.  In this mode QEMU emulates a full system, including a
 processor and various peripherals.  It enables easier testing and debugging
 of system code.  It can also be used to provide virtual hosting of several
 virtual machines on a single server.

Package: qemu-user
Architecture: amd64 arm armel armhf hppa i386 ia64 mips mipsel powerpc sparc sparc64 ppc64
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: qemu (<< 0.11.0-2), qemu-kvm-extras (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Replaces: qemu (<< 0.11.0-2), qemu-kvm-extras (<< 0.13.50-2011.02-0~rc1-0ubuntu1), qemu-kvm (<< 0.13.0+noroms-0ubuntu13)
Description: QEMU user mode emulation binaries
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the user mode emulation binaries for targets other
 than x86 and x86-64.  In this mode QEMU can launch Linux processes compiled
 for one CPU on another CPU.

Package: qemu-user-static
Architecture: amd64 arm armel armhf hppa i386 ia64 mips mipsel powerpc sparc sparc64 ppc64
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: binfmt-support, debootstrap
Breaks: qemu-kvm-extras-static (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Replaces: qemu-kvm-extras-static (<< 0.13.50-2011.02-0~rc1-0ubuntu1)
Suggests: sudo
Description: QEMU user mode emulation binaries (static version)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the user mode emulation binaries, built
 statically. In this mode QEMU can launch Linux processes compiled for
 one CPU on another CPU.

Package: qemu-kvm-extras
Architecture: all
Depends: qemu-system, qemu-user
Description: QEMU system and user mode emulation (transitional package)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This is a transitional package depending on the system and user mode
 emulation binaries.  You can remove it once the upgrade is complete and
 nothing depends on it.

Package: qemu-kvm-extras-static
Architecture: all
Depends: qemu-user-static
Description: QEMU static user mode emulation binaries (transitional package)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This is a transitional package depending on the static user mode emulation
 binaries.  You can remove it once the upgrade is complete and nothing
 depends on it.

=== debian/rules ===
#!/usr/bin/make -f

deb_source := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
deb_version := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
upstream_version := $(shell echo '$(deb_version)' | sed 's/.*://; s/-[^-]*$$//')
git_rev := $(shell echo '$(upstream_version)' | sed 's/.*+//')

DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_CPU = $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_GNU_CPU = $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_TYPE = $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE = $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)

QEMU_CPU = $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
ifeq ($(QEMU_CPU),powerpc)
  QEMU_CPU = ppc
endif
ifneq (,$(filter $(DEB_HOST_ARCH),armel armhf))
  QEMU_CPU = armv4l
endif

ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  conf_arch += --cc=$(DEB_HOST_GNU_TYPE)-gcc --cpu=$(QEMU_CPU)
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
       conf_audio_drv += --audio-drv-list=alsa,oss,sdl,pa
endif
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
       conf_audio_drv += --audio-drv-list=oss,sdl,pa
endif
# KVM on PowerPC needs at least 2.6.33 kernel headers
ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
       conf_arch += --disable-kvm
endif

# binfmt support
ALL_BINFMT_TARGETS=alpha arm armeb cris i386 m68k microblaze mips mipsel ppc ppc64 ppc64abi32 sh4 sh4eb sparc sparc32plus sparc64 x86_64
ifeq ($(DEB_HOST_ARCH),amd64)
BINFMT_TARGETS=$(filter-out i386 x86_64, $(ALL_BINFMT_TARGETS))
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf))
BINFMT_TARGETS=$(filter-out arm, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),i386)
BINFMT_TARGETS=$(filter-out i386, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),powerpc)
BINFMT_TARGETS=$(filter-out ppc, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),ppc64)
BINFMT_TARGETS=$(filter-out ppc ppc64 ppc64abi32 , $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),sparc)
BINFMT_TARGETS=$(filter-out sparc sparc32plus sparc64, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(DEB_HOST_ARCH),sparc64)
BINFMT_TARGETS=$(filter-out sparc sparc32plus sparc64, $(ALL_BINFMT_TARGETS))
endif
ifeq ($(BINFMT_TARGETS),)
BINFMT_TARGETS=$(ALL_BINFMT_TARGETS)
endif

# namespace to use for data files
NAMESPACE := linaro

# basedir in which to install BIOSes and keymaps below prefix
DATASUBDIR := share/qemu-$(NAMESPACE)
DATADIR := /usr/$(DATASUBDIR)
# XXX doesn't work because it's #defined in the source should send an upstream
# patch to allow ./configuring that
#CFLAGS += -DSHARE_SUFFIX="$(DATASUBDIR)"

# Workaround for var tracking blowing up the memory requirements more than
# tenfold on armel; we'll keep -g enabled but disable this particular feature
ifneq (,$(findstring $(DEB_HOST_ARCH), armel armhf))
CFLAGS += -fno-var-tracking
endif

# XXX for some reason, --remote doesn't work with gitorious so this needs to be
# run from a local checkout
# --remote=git://gitorious.org/qemu-maemo/qemu-maemo.git
get-orig-source:
	git archive \
	    --format=tar \
	    --prefix=$(deb_source)-$(upstream_version)/ \
	    $(git_rev) \
	    | gzip >$(deb_source)_$(upstream_version).orig.tar.gz

override_dh_auto_configure:
	# system build
	mkdir -p $(CURDIR)/system-build
	cd $(CURDIR)/system-build && \
		../configure \
		    --with-pkgversion="Debian $(deb_version)" \
		    --extra-cflags="$(CFLAGS)" \
		    --extra-ldflags="$(LDFLAGS)" \
		    --prefix=/usr \
		    --datadir=$(DATADIR) \
		    --interp-prefix=/etc/qemu-binfmt/%M \
		    --disable-blobs \
		    --disable-strip \
		    --disable-linux-user \
		    --disable-bsd-user \
		    --disable-darwin-user \
		    $(conf_arch) $(conf_audio_drv)

ifeq ($(DEB_HOST_ARCH_OS),linux)
	# user build
	mkdir -p $(CURDIR)/user-build
	cd $(CURDIR)/user-build && \
		../configure \
		    --with-pkgversion="Debian $(deb_version)" \
		    --extra-cflags="$(CFLAGS)" \
		    --extra-ldflags="$(LDFLAGS)" \
		    --prefix=/usr \
		    --datadir=$(DATADIR) \
		    --interp-prefix=/etc/qemu-binfmt/%M \
		    --disable-blobs \
		    --disable-strip \
		    --disable-system \
		    $(conf_arch)

	# static user build
	mkdir -p $(CURDIR)/user-static-build
	cd $(CURDIR)/user-static-build && \
		../configure \
		    --with-pkgversion="Debian $(deb_version)" \
		    --extra-cflags="$(CFLAGS)" \
		    --extra-ldflags="$(LDFLAGS)" \
		    --prefix=/usr \
		    --datadir=$(DATADIR) \
		    --interp-prefix=/etc/qemu-binfmt/%M \
		    --disable-blobs \
		    --disable-strip \
		    --disable-system \
		    --static \
		    $(conf_arch)
endif

override_dh_auto_build:
	# system build
	dh_auto_build -B system-build
ifeq ($(DEB_HOST_ARCH_OS),linux)
	# user build
	dh_auto_build -B user-build

	# static user build
	dh_auto_build -B user-static-build
endif

override_dh_auto_install:
ifeq ($(DEB_HOST_ARCH_OS),linux)
	dh_auto_install -B user-static-build --destdir=$(CURDIR)/debian/tmp
	for script in prerm postinst; do \
		sed -e 's/^BINFMT_TARGETS=.*/BINFMT_TARGETS=\"$(BINFMT_TARGETS)\"/g' \
                $(CURDIR)/debian/qemu-user-static.$$script.in \
		> $(CURDIR)/debian/qemu-user-static.$$script; \
	done
	for target in $(CURDIR)/debian/tmp/usr/bin/qemu-*; do \
		install -m 755 $$target $(CURDIR)/debian/tmp/usr/bin/$$(basename $$target)-static; \
	done
	dh_auto_install -B user-build --destdir=$(CURDIR)/debian/tmp
	for target in $(BINFMT_TARGETS) ; do \
		install -m 644 $(CURDIR)/debian/binfmts/qemu-$$target \
			$(CURDIR)/debian/qemu-user-static/usr/share/binfmts ; \
	done
	f=debian/qemu-user-static.sysctl; [ -f debian/qemu-user-static.sysctl.$(DEB_BUILD_ARCH) ] && f=debian/qemu-user-static.sysctl.$(DEB_BUILD_ARCH); cp $$f debian/qemu-user-static/etc/sysctl.d/30-qemu-user-static.conf
endif
	dh_auto_install -B system-build --destdir=$(CURDIR)/debian/tmp
	mv $(CURDIR)/debian/tmp/usr/share/man/man1/qemu.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/qemu-system.1

override_dh_auto_clean:
	rm -rf user-static-build user-build system-build

override_dh_auto_test:
	# tests are broken ATM

%:
	dh $@

.PHONY: get-orig-source

=== debian/watch ===
version=3
opts=uversionmangle=s/-rc/~rc/,dversionmangle=s/\+dfsg\d*$// \
https://launchpad.net/qemu-linaro/+download http://launchpad.net/qemu-linaro/.*/.*/\+download/qemu-linaro-(.+).tar.gz

## qemu-linaro 1.0.50

=== Makefile ===
# Makefile for QEMU.

# Always point to the root of the build tree (needs GNU make).
BUILD_DIR=$(CURDIR)

GENERATED_HEADERS = config-host.h trace.h qemu-options.def
ifeq ($(TRACE_BACKEND),dtrace)
GENERATED_HEADERS += trace-dtrace.h
endif
GENERATED_HEADERS += qmp-commands.h qapi-types.h qapi-visit.h
GENERATED_SOURCES += qmp-marshal.c qapi-types.c qapi-visit.c

ifneq ($(wildcard config-host.mak),)
# Put the all: rule here so that config-host.mak can contain dependencies.
all: build-all
include config-host.mak
include $(SRC_PATH)/rules.mak
config-host.mak: $(SRC_PATH)/configure
	@echo $@ is out-of-date, running configure
	@sed -n "/.*Configured with/s/[^:]*: //p" $@ | sh
else
config-host.mak:
	@echo "Please call configure before running make!"
	@exit 1
endif

# Don't try to regenerate Makefile or configure
# We don't generate any of them
Makefile: ;
configure: ;

.PHONY: all clean cscope distclean dvi html info install install-doc \
	pdf recurse-all speed tar tarbin test build-all

$(call set-vpath, $(SRC_PATH):$(SRC_PATH)/hw)

LIBS+=-lz $(LIBS_TOOLS)

HELPERS-$(CONFIG_LINUX) = qemu-bridge-helper$(EXESUF)

ifdef BUILD_DOCS
DOCS=qemu-doc.html qemu-tech.html qemu.1 qemu-img.1 qemu-nbd.8 QMP/qmp-commands.txt
ifdef CONFIG_VIRTFS
DOCS+=fsdev/virtfs-proxy-helper.1
endif
else
DOCS=
endif

SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory) BUILD_DIR=$(BUILD_DIR)
SUBDIR_DEVICES_MAK=$(patsubst %, %/config-devices.mak, $(TARGET_DIRS))
SUBDIR_DEVICES_MAK_DEP=$(patsubst %, %/config-devices.mak.d, $(TARGET_DIRS))

config-all-devices.mak: $(SUBDIR_DEVICES_MAK)
	$(call quiet-command,cat $(SUBDIR_DEVICES_MAK) | grep =y | sort -u > $@,"  GEN   $@")

-include $(SUBDIR_DEVICES_MAK_DEP)

%/config-devices.mak: default-configs/%.mak
	$(call quiet-command,$(SHELL) $(SRC_PATH)/scripts/make_device_config.sh $@ $<, "  GEN   $@")
	@if test -f $@; then \
	  if cmp -s $@.old $@; then \
	    mv $@.tmp $@; \
	    cp -p $@ $@.old; \
	  else \
	    if test -f $@.old; then \
	      echo "WARNING: $@ (user modified) out of date.";\
	    else \
	      echo "WARNING: $@ out of date.";\
	    fi; \
	    echo "Run \"make defconfig\" to regenerate."; \
	    rm $@.tmp; \
	  fi; \
	 else \
	  mv $@.tmp $@; \
	  cp -p $@ $@.old; \
	 fi

defconfig:
	rm -f config-all-devices.mak $(SUBDIR_DEVICES_MAK)

-include config-all-devices.mak

build-all: $(DOCS) $(TOOLS) $(HELPERS-y) recurse-all

config-host.h: config-host.h-timestamp
config-host.h-timestamp: config-host.mak
qemu-options.def: $(SRC_PATH)/qemu-options.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

SUBDIR_RULES=$(patsubst %,subdir-%, $(TARGET_DIRS))

subdir-%: $(GENERATED_HEADERS)
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $* V="$(V)" TARGET_DIR="$*/" all,)

ifneq ($(wildcard config-host.mak),)
include $(SRC_PATH)/Makefile.objs
endif

$(common-obj-y): $(GENERATED_HEADERS)
subdir-libcacard: $(oslib-obj-y) $(trace-obj-y) qemu-timer-common.o

$(filter %-softmmu,$(SUBDIR_RULES)): $(trace-obj-y) $(common-obj-y) subdir-libdis

$(filter %-user,$(SUBDIR_RULES)): $(GENERATED_HEADERS) $(trace-obj-y) subdir-libdis-user subdir-libuser

ROMSUBDIR_RULES=$(patsubst %,romsubdir-%, $(ROMS))
romsubdir-%:
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C pc-bios/$* V="$(V)" TARGET_DIR="$*/",)

ALL_SUBDIRS=$(TARGET_DIRS) $(patsubst %,pc-bios/%, $(ROMS))

recurse-all: $(SUBDIR_RULES) $(ROMSUBDIR_RULES)

audio/audio.o audio/fmodaudio.o: QEMU_CFLAGS += $(FMOD_CFLAGS)

QEMU_CFLAGS+=$(CURL_CFLAGS)

QEMU_CFLAGS += -I$(SRC_PATH)/include

ui/cocoa.o: ui/cocoa.m

ui/sdl.o audio/sdlaudio.o ui/sdl_zoom.o baum.o: QEMU_CFLAGS += $(SDL_CFLAGS)

ui/vnc.o: QEMU_CFLAGS += $(VNC_TLS_CFLAGS)

bt-host.o: QEMU_CFLAGS += $(BLUEZ_CFLAGS)

version.o: $(SRC_PATH)/version.rc config-host.h
	$(call quiet-command,$(WINDRES) -I. -o $@ $<,"  RC    $(TARGET_DIR)$@")

version-obj-$(CONFIG_WIN32) += version.o
######################################################################
# Support building shared library libcacard

.PHONY: libcacard.la install-libcacard
ifeq ($(LIBTOOL),)
libcacard.la:
	@echo "libtool is missing, please install and rerun configure"; exit 1

install-libcacard:
	@echo "libtool is missing, please install and rerun configure"; exit 1
else
libcacard.la: $(GENERATED_HEADERS) $(oslib-obj-y) qemu-timer-common.o $(addsuffix .lo, $(basename $(trace-obj-y)))
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" libcacard.la,)

install-libcacard: libcacard.la
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" install-libcacard,)
endif
######################################################################

qemu-img.o: qemu-img-cmds.h
qemu-img.o qemu-tool.o qemu-nbd.o qemu-io.o cmd.o qemu-ga.o: $(GENERATED_HEADERS)

tools-obj-y = $(oslib-obj-y) $(trace-obj-y) qemu-tool.o qemu-timer.o \
	qemu-timer-common.o main-loop.o notify.o iohandler.o cutils.o async.o
tools-obj-$(CONFIG_POSIX) += compatfd.o

qemu-img$(EXESUF): qemu-img.o $(tools-obj-y) $(block-obj-y)
qemu-nbd$(EXESUF): qemu-nbd.o $(tools-obj-y) $(block-obj-y)
qemu-io$(EXESUF): qemu-io.o cmd.o $(tools-obj-y) $(block-obj-y)

qemu-bridge-helper$(EXESUF): qemu-bridge-helper.o
qemu-bridge-helper.o: $(GENERATED_HEADERS)

fsdev/virtfs-proxy-helper$(EXESUF): fsdev/virtfs-proxy-helper.o fsdev/virtio-9p-marshal.o oslib-posix.o $(trace-obj-y)
fsdev/virtfs-proxy-helper$(EXESUF): LIBS += -lcap

qemu-img-cmds.h: $(SRC_PATH)/qemu-img-cmds.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

$(qapi-obj-y): $(GENERATED_HEADERS)
qapi-dir := $(BUILD_DIR)/qapi-generated
qemu-ga$(EXESUF): LIBS = $(LIBS_QGA)

gen-out-type = $(subst .,-,$(suffix $@))

ifneq ($(wildcard config-host.mak),)
include $(SRC_PATH)/tests/Makefile
endif

$(qapi-dir)/qga-qapi-types.c $(qapi-dir)/qga-qapi-types.h :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-types.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o "$(qapi-dir)" -p "qga-" < $<, "  GEN   $@")
$(qapi-dir)/qga-qapi-visit.c $(qapi-dir)/qga-qapi-visit.h :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-visit.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o "$(qapi-dir)" -p "qga-" < $<, "  GEN   $@")
$(qapi-dir)/qga-qmp-commands.h $(qapi-dir)/qga-qmp-marshal.c :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-commands.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -o "$(qapi-dir)" -p "qga-" < $<, "  GEN   $@")

qapi-types.c qapi-types.h :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-types.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o "." < $<, "  GEN   $@")
qapi-visit.c qapi-visit.h :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-visit.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o "."  < $<, "  GEN   $@")
qmp-commands.h qmp-marshal.c :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-commands.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -m -o "." < $<, "  GEN   $@")

QGALIB_OBJ=$(addprefix $(qapi-dir)/, qga-qapi-types.o qga-qapi-visit.o qga-qmp-marshal.o)
QGALIB_GEN=$(addprefix $(qapi-dir)/, qga-qapi-types.h qga-qapi-visit.h qga-qmp-commands.h)
$(QGALIB_OBJ): $(QGALIB_GEN) $(GENERATED_HEADERS)
$(qga-obj-y) qemu-ga.o: $(QGALIB_GEN) $(GENERATED_HEADERS)

qemu-ga$(EXESUF): qemu-ga.o $(qga-obj-y) $(tools-obj-y) $(qapi-obj-y) $(qobject-obj-y) $(version-obj-y) $(QGALIB_OBJ)

QEMULIBS=libhw32 libhw64 libuser libdis libdis-user

clean:
# avoid old build problems by removing potentially incorrect old files
	rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
	rm -f qemu-options.def
	rm -f *.o *.d *.a *.lo $(TOOLS) $(HELPERS-y) qemu-ga TAGS cscope.* *.pod *~ */*~
	rm -Rf .libs
	rm -f slirp/*.o slirp/*.d audio/*.o audio/*.d block/*.o block/*.d net/*.o net/*.d fsdev/*.o fsdev/*.d ui/*.o ui/*.d qapi/*.o qapi/*.d qga/*.o qga/*.d
	rm -f qemu-img-cmds.h
	rm -f trace/*.o trace/*.d
	rm -f trace.c trace.h trace.c-timestamp trace.h-timestamp
	rm -f trace-dtrace.dtrace trace-dtrace.dtrace-timestamp
	rm -f trace-dtrace.h trace-dtrace.h-timestamp
	rm -f $(GENERATED_HEADERS)
	rm -f $(GENERATED_SOURCES)
	rm -rf $(qapi-dir)
	$(MAKE) -C tests/tcg clean
	for d in $(ALL_SUBDIRS) $(QEMULIBS) libcacard; do \
	if test -d $$d; then $(MAKE) -C $$d $@ || exit 1; fi; \
	rm -f $$d/qemu-options.def; \
        done

distclean: clean
	rm -f config-host.mak config-host.h* config-host.ld $(DOCS) qemu-options.texi qemu-img-cmds.texi qemu-monitor.texi
	rm -f config-all-devices.mak
	rm -f roms/seabios/config.mak roms/vgabios/config.mak
	rm -f qemu-doc.info qemu-doc.aux qemu-doc.cp qemu-doc.cps qemu-doc.dvi
	rm -f qemu-doc.fn qemu-doc.fns qemu-doc.info qemu-doc.ky qemu-doc.kys
	rm -f qemu-doc.log qemu-doc.pdf qemu-doc.pg qemu-doc.toc qemu-doc.tp
	rm -f qemu-doc.vr
	rm -f config.log
	rm -f linux-headers/asm
	rm -f qemu-tech.info qemu-tech.aux qemu-tech.cp qemu-tech.dvi qemu-tech.fn qemu-tech.info qemu-tech.ky qemu-tech.log qemu-tech.pdf qemu-tech.pg qemu-tech.toc qemu-tech.tp qemu-tech.vr
	for d in $(TARGET_DIRS) $(QEMULIBS); do \
	rm -rf $$d || exit 1 ; \
        done

KEYMAPS=da     en-gb  et  fr     fr-ch  is  lt  modifiers  no  pt-br  sv \
ar      de     en-us  fi  fr-be  hr     it  lv  nl         pl  ru     th \
common  de-ch  es     fo  fr-ca  hu     ja  mk  nl-be      pt  sl     tr

ifdef INSTALL_BLOBS
BLOBS=bios.bin sgabios.bin vgabios.bin vgabios-cirrus.bin \
vgabios-stdvga.bin vgabios-vmware.bin vgabios-qxl.bin \
ppc_rom.bin openbios-sparc32 openbios-sparc64 openbios-ppc \
pxe-e1000.rom pxe-eepro100.rom pxe-ne2k_pci.rom \
pxe-pcnet.rom pxe-rtl8139.rom pxe-virtio.rom \
bamboo.dtb petalogix-s3adsp1800.dtb petalogix-ml605.dtb \
mpc8544ds.dtb \
multiboot.bin linuxboot.bin kvmvapic.bin \
s390-zipl.rom \
spapr-rtas.bin slof.bin \
palcode-clipper
else
BLOBS=
endif

install-doc: $(DOCS)
	$(INSTALL_DIR) "$(DESTDIR)$(docdir)"
	$(INSTALL_DATA) qemu-doc.html  qemu-tech.html "$(DESTDIR)$(docdir)"
ifdef CONFIG_POSIX
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DATA) qemu.1 qemu-img.1 "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man8"
	$(INSTALL_DATA) qemu-nbd.8 "$(DESTDIR)$(mandir)/man8"
endif
ifdef CONFIG_VIRTFS
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DATA) fsdev/virtfs-proxy-helper.1 "$(DESTDIR)$(mandir)/man1"
endif
install-sysconfig:
	$(INSTALL_DIR) "$(DESTDIR)$(sysconfdir)/qemu"
	$(INSTALL_DATA) $(SRC_PATH)/sysconfigs/target/target-x86_64.conf "$(DESTDIR)$(sysconfdir)/qemu"

install: all $(if $(BUILD_DOCS),install-doc) install-sysconfig
	$(INSTALL_DIR) "$(DESTDIR)$(bindir)"
ifneq ($(TOOLS),)
	$(INSTALL_PROG) $(STRIP_OPT) $(TOOLS) "$(DESTDIR)$(bindir)"
endif
ifneq ($(HELPERS-y),)
	$(INSTALL_DIR) "$(DESTDIR)$(libexecdir)"
	$(INSTALL_PROG) $(STRIP_OPT) $(HELPERS-y) "$(DESTDIR)$(libexecdir)"
endif
ifneq ($(BLOBS),)
	$(INSTALL_DIR) "$(DESTDIR)$(datadir)"
	set -e; for x in $(BLOBS); do \
		[ -e "$(SRC_PATH)/pc-bios/$$x" ] || continue; \
		$(INSTALL_DATA) $(SRC_PATH)/pc-bios/$$x "$(DESTDIR)$(datadir)"; \
	done
endif
	$(INSTALL_DIR) "$(DESTDIR)$(datadir)/keymaps"
	set -e; for x in $(KEYMAPS); do \
		$(INSTALL_DATA) $(SRC_PATH)/pc-bios/keymaps/$$x "$(DESTDIR)$(datadir)/keymaps"; \
	done
	for d in $(TARGET_DIRS); do \
	$(MAKE) -C $$d $@ || exit 1 ; \
        done

# various test targets
test speed: all
	$(MAKE) -C tests/tcg $@

.PHONY: TAGS
TAGS:
	find "$(SRC_PATH)" -name '*.[hc]' -print0 | xargs -0 etags

cscope:
	rm -f ./cscope.*
	find "$(SRC_PATH)" -name "*.[chsS]" -print | sed 's,^\./,,' > ./cscope.files
	cscope -b

# documentation
MAKEINFO=makeinfo
MAKEINFOFLAGS=--no-headers --no-split --number-sections
TEXIFLAG=$(if $(V),,--quiet)
%.dvi: %.texi
	$(call quiet-command,texi2dvi $(TEXIFLAG) -I . $<,"  GEN   $@")

%.html: %.texi

=== qom/Makefile ===
qom-y = object.o container.o qom-qobject.o

=== tests/Makefile ===
CHECKS = check-qdict check-qfloat check-qint check-qstring check-qlist
CHECKS += check-qjson test-qmp-output-visitor test-qmp-input-visitor
CHECKS += test-string-input-visitor test-string-output-visitor test-coroutine

check-qint.o check-qstring.o check-qdict.o check-qlist.o check-qfloat.o check-qjson.o test-coroutine.o: $(GENERATED_HEADERS)

check-qint: check-qint.o qint.o $(tools-obj-y)
check-qstring: check-qstring.o qstring.o $(tools-obj-y)
check-qdict: check-qdict.o qdict.o qfloat.o qint.o qstring.o qbool.o qlist.o $(tools-obj-y)
check-qlist: check-qlist.o qlist.o qint.o $(tools-obj-y)
check-qfloat: check-qfloat.o qfloat.o $(tools-obj-y)
check-qjson: check-qjson.o $(qobject-obj-y) $(tools-obj-y)
test-coroutine: test-coroutine.o qemu-timer-common.o async.o $(coroutine-obj-y) $(tools-obj-y)

test-qmp-input-visitor.o test-qmp-output-visitor.o \
test-string-input-visitor.o test-string-output-visitor.o \
	test-qmp-commands.o qemu-ga$(EXESUF): QEMU_CFLAGS += -I $(qapi-dir)

$(qapi-dir)/test-qapi-types.c $(qapi-dir)/test-qapi-types.h :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-types.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o "$(qapi-dir)" -p "test-" < $<, "  GEN   $@")
$(qapi-dir)/test-qapi-visit.c $(qapi-dir)/test-qapi-visit.h :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-visit.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o "$(qapi-dir)" -p "test-" < $<, "  GEN   $@")
$(qapi-dir)/test-qmp-commands.h $(qapi-dir)/test-qmp-marshal.c :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-commands.py
	    $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -o "$(qapi-dir)" -p "test-" < $<, "  GEN   $@")


test-string-output-visitor.o: $(addprefix $(qapi-dir)/, test-qapi-types.c test-qapi-types.h test-qapi-visit.c test-qapi-visit.h) $(qapi-obj-y)
test-string-output-visitor: test-string-output-visitor.o $(qobject-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qapi-dir)/test-qapi-visit.o $(qapi-dir)/test-qapi-types.o

test-string-input-visitor.o: $(addprefix $(qapi-dir)/, test-qapi-types.c test-qapi-types.h test-qapi-visit.c test-qapi-visit.h) $(qapi-obj-y)
test-string-input-visitor: test-string-input-visitor.o $(qobject-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qapi-dir)/test-qapi-visit.o $(qapi-dir)/test-qapi-types.o

test-qmp-output-visitor.o: $(addprefix $(qapi-dir)/, test-qapi-types.c test-qapi-types.h test-qapi-visit.c test-qapi-visit.h) $(qapi-obj-y)
test-qmp-output-visitor: test-qmp-output-visitor.o $(qobject-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qapi-dir)/test-qapi-visit.o $(qapi-dir)/test-qapi-types.o

test-qmp-input-visitor.o: $(addprefix $(qapi-dir)/, test-qapi-types.c test-qapi-types.h test-qapi-visit.c test-qapi-visit.h) $(qapi-obj-y)
test-qmp-input-visitor: test-qmp-input-visitor.o $(qobject-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qapi-dir)/test-qapi-visit.o $(qapi-dir)/test-qapi-types.o

test-qmp-commands.o: $(addprefix $(qapi-dir)/, test-qapi-types.c test-qapi-types.h test-qapi-visit.c test-qapi-visit.h test-qmp-marshal.c test-qmp-commands.h) $(qapi-obj-y)
test-qmp-commands: test-qmp-commands.o $(qobject-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qapi-dir)/test-qapi-visit.o $(qapi-dir)/test-qapi-types.o $(qapi-dir)/test-qmp-marshal.o module.o

.PHONY: check
check: $(CHECKS)
	$(call quiet-command, gtester $(CHECKS), "  CHECK")

=== pc-bios/optionrom/Makefile ===
all: build-all
# Dummy command so that make thinks it has done something
	@true

include ../../config-host.mak
include $(SRC_PATH)/rules.mak

$(call set-vpath, $(SRC_PATH)/pc-bios/optionrom)

.PHONY : all clean build-all

CFLAGS := -Wall -Wstrict-prototypes -Werror -fomit-frame-pointer -fno-builtin
CFLAGS += -I$(SRC_PATH)
CFLAGS += $(call cc-option, $(CFLAGS), -fno-stack-protector)
QEMU_CFLAGS = $(CFLAGS)

build-all: multiboot.bin linuxboot.bin kvmvapic.bin

# suppress auto-removal of intermediate files
.SECONDARY:

%.img: %.o
	$(call quiet-command,$(LD) -Ttext 0 -e _start -s -o $@ $<,"  Building $(TARGET_DIR)$@")

%.raw: %.img
	$(call quiet-command,$(OBJCOPY) -O binary -j .text $< $@,"  Building $(TARGET_DIR)$@")

%.bin: %.raw
	$(call quiet-command,$(SHELL) $(SRC_PATH)/scripts/signrom.sh $< $@,"  Signing $(TARGET_DIR)$@")

clean:
	rm -f *.o *.d *.raw *.img *.bin *~

=== tests/tcg/xtensa/Makefile ===
-include ../../config-host.mak

CROSS=xtensa-dc232b-elf-

ifndef XT
SIM = qemu-system-xtensa
SIMFLAGS = -M sim -cpu dc232b -nographic -semihosting $(EXTFLAGS) -kernel
SIMDEBUG = -s -S
else
SIM = xt-run
SIMFLAGS = --xtensa-core=DC_B_232L --exit_with_target_code $(EXTFLAGS)
SIMDEBUG = --gdbserve=0
endif

CC      = $(CROSS)gcc
AS      = $(CROSS)gcc -x assembler
LD      = $(CROSS)ld

LDFLAGS = -Tlinker.ld

CRT        = crt.o vectors.o

TESTCASES += test_b.tst
TESTCASES += test_bi.tst
#TESTCASES += test_boolean.tst
TESTCASES += test_break.tst
TESTCASES += test_bz.tst
TESTCASES += test_clamps.tst
TESTCASES += test_fail.tst
TESTCASES += test_interrupt.tst
TESTCASES += test_loop.tst
TESTCASES += test_mac16.tst
TESTCASES += test_max.tst
TESTCASES += test_min.tst
TESTCASES += test_mmu.tst
TESTCASES += test_mul16.tst
TESTCASES += test_mul32.tst
TESTCASES += test_nsa.tst
ifdef XT
TESTCASES += test_pipeline.tst
endif
TESTCASES += test_quo.tst
TESTCASES += test_rem.tst
TESTCASES += test_rst0.tst
TESTCASES += test_sar.tst
TESTCASES += test_sext.tst
TESTCASES += test_shift.tst
TESTCASES += test_timer.tst
TESTCASES += test_windowed.tst

all: build

%.o: $(SRC_PATH)/tests/xtensa/%.c
	$(CC) $(CFLAGS) -c $< -o $@

%.o: $(SRC_PATH)/tests/xtensa/%.S
	$(AS) $(ASFLAGS) -c $< -o $@

%.tst: %.o macros.inc $(CRT) Makefile
	$(LD) $(LDFLAGS) $(NOSTDFLAGS) $(CRT) $< -o $@

build: $(TESTCASES)

check: $(addprefix run-, $(TESTCASES))

run-%.tst: %.tst
	$(SIM) $(SIMFLAGS) ./$<

run-test_fail.tst: test_fail.tst
	! $(SIM) $(SIMFLAGS) ./$<

debug-%.tst: %.tst
	$(SIM) $(SIMDEBUG) $(SIMFLAGS) ./$<

clean:
	$(RM) -fr $(TESTCASES) $(CRT)

## qemu-linaro 1.0.50-2012.03

=== debian/changelog ===
qemu-linaro (1.0.50-2012.03-0ubuntu2) precise; urgency=low

  * Add missing #include that caused a build failure on powerpc.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 22 Apr 2012 14:54:06 +0100

qemu-linaro (1.0.50-2012.03-0ubuntu1) precise; urgency=low

  * Update watch file since launchpad now uses https for the download links.
  * New upstream release.
    - Fixes use of deprecated gthread calls when building on arm.
      LP: #928555.
  * Drop 0001_linux-user-reserve-4GB-of-vmem-for-32-on-64.patch, included
    upstream with some follow-on fixes.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 15 Mar 2012 16:18:18 -0700

qemu-linaro (1.0.50-2012.02-0ubuntu1) precise; urgency=low

  * New upstream release.
  * Pass --enable-uname-release=2.6.32 for the user emulation builds, so that
    we have a sensible baseline kernel value regardless of what the
    underlying host kernel is.  This makes eglibc happier when running under
    emulation on a very old kernel for instance (whose host syscall ABI has
    nothing to do with what emulated syscalls are supported), and probably
    also lets us steer clear for the moment of code that has problem with
    the new kernel upstream versioning convention.  LP: #921078.
  * debian/patches/define_AT_EMPTY_PATH.patch: make sure AT_EMPTY_PATH
    is defined.  Thanks to Serge Hallyn <serge.hallyn@ubuntu.com>.
    Closes LP: #930181.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 20 Feb 2012 17:32:06 -0800

qemu-linaro (1.0.50-2012.01-0ubuntu4) precise; urgency=low

  * New patch, 0001_linux-user-reserve-4GB-of-vmem-for-32-on-64, from
    http://lists.gnu.org/archive/html/qemu-devel/2011-12/msg01697.html; fixes
    mmap when running a 32-bits guest on a 64-bits host; LP: #906922.

 -- Loïc Minier <loic.minier@ubuntu.com>  Fri, 17 Feb 2012 11:27:00 +0100

qemu-linaro (1.0.50-2012.01-0ubuntu3) precise; urgency=low

  * Don't build the qemu-kvm-spice package on i386, spice is 64-bit-only.
    LP: #928432.
  * This means we don't have to disable -Werror on the spice build anymore.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Feb 2012 23:34:36 +0000

qemu-linaro (1.0.50-2012.01-0ubuntu2) precise; urgency=low

  * Turn off -Werror for the spice build: the spice API uses a 64-bit 
    integer type for storing pointers even on 32-bit systems, leading to
    warnings about wrong casts that we can safely ignore here.  LP: #926195.
  * Pass --disable-spice to the system build, otherwise it ends up having
    spice enabled as well.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Feb 2012 11:09:14 -0800

qemu-linaro (1.0.50-2012.01-0ubuntu1) precise; urgency=low

  * New upstream release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 02 Feb 2012 14:25:28 -0800

qemu-linaro (1.0-2011.12-0ubuntu1) precise; urgency=low

  * New upstream release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 14 Dec 2011 16:58:18 -0800

qemu-linaro (0.15.91-2011.11-0ubuntu1) precise; urgency=low

  * New upstream release.
    - fixes segfaults of aptitude under qemu-arm-static.  LP: #898474.
  * debian/patches/1-tcg-ppc-tcg-target.c-Avoid-set-but-not-used-gcc-warn.patch:
    drop, addressed upstream.
  * Drop use of -Wno-error=deprecated-declarations build option, no longer
    needed for gnutls compatibility.

  [ Serge Hallyn ]
  * Add qemu-kvm-spice package
    - debian/control: add libspice-protocol-dev and libspice-server-dev
      to build-depends, define the qemu-kvm-spice package,
      remove all other packages, and rename source package to qemu-kvm.
    - debian/rules:
      * keep only spice-enabled binaries
      * rename our binaries to '-spice'
    - debian/qemu-kvm-spice.links and debian/qemu-kvm-spice.install: install
      kvm-spice and qemu-system-x86_64-spice

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 06 Dec 2011 09:35:22 -0800

qemu-linaro (0.15.50-2011.10-0ubuntu1) precise; urgency=low

  * New upstream release.
  * debian/patches/6-6-tcg-arm-Make-tcg_out_addi-inline.patch,
    debian/patches/5-6-tcg-ia64-Fix-typos-in-AREG0-setup-in-prologue..patch,
    debian/patches/target-cris-opcode-cris.h-rename-REG_PC-SP-to-CRIS_REG_PC-SP.patch,
    debian/patches/Reorder-default-ram_size-initialization.patch:
    drop, addressed upstream.
  * Build with -Wno-error=deprecated-declarations, to work around a build
    failure due to use of deprecated gnutls functions.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 28 Oct 2011 17:37:30 +0000

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,8 @@
                libcurl4-gnutls-dev,
                libgnutls-dev,
                libsasl2-dev,
+               libspice-protocol-dev [amd64],
+               libspice-server-dev [amd64],
                uuid-dev,
                libvdeplug2-dev [!kfreebsd-any],
                libbluetooth-dev [!kfreebsd-any],
@@ -116,3 +118,9 @@
  This is a transitional package depending on the static user mode emulation
  binaries.  You can remove it once the upgrade is complete and nothing
  depends on it.
+
+Package: qemu-kvm-spice
+Architecture: amd64
+Depends: qemu-kvm, ${misc:Depends}, ${shlibs:Depends}, libspice-server1
+Description: Full virtualization on amd64 hardware
+ This adds versions of qemu-kvm which can use SPICE, called qemu-kvm-spice.

=== debian/rules ===
--- 
+++ 
@@ -105,6 +105,7 @@
 		    --disable-linux-user \
 		    --disable-bsd-user \
 		    --disable-darwin-user \
+		    --disable-spice \
 		    $(conf_arch) $(conf_audio_drv)
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
@@ -121,6 +122,7 @@
 		    --disable-blobs \
 		    --disable-strip \
 		    --disable-system \
+		    --enable-uname-release=2.6.32 \
 		    $(conf_arch)
 
 	# static user build
@@ -137,7 +139,26 @@
 		    --disable-strip \
 		    --disable-system \
 		    --static \
+		    --enable-uname-release=2.6.32 \
 		    $(conf_arch)
+
+ifeq ($(DEB_HOST_ARCH),amd64)
+	# spice build
+	mkdir -p $(CURDIR)/spice-build
+	cd $(CURDIR)/spice-build && \
+		../configure \
+		    --with-pkgversion="Debian $(deb_version)" \
+		    --extra-cflags="$(CFLAGS)" \
+		    --extra-ldflags="$(LDFLAGS)" \
+		    --prefix=/usr \
+		    --interp-prefix=/etc/qemu-binfmt/%M \
+		    --disable-blobs \
+		    --disable-strip \
+		    --disable-system \
+		    --target-list="x86_64-softmmu i386-softmmu x86_64-linux-user i386-linux-user" \
+		    --enable-spice \
+		    $(conf_arch)
+endif
 endif
 
 override_dh_auto_build:
@@ -149,6 +170,11 @@
 
 	# static user build
 	dh_auto_build -B user-static-build
+
+ifeq ($(DEB_HOST_ARCH),amd64)
+	# spice build
+	dh_auto_build -B spice-build
+endif
 endif
 
 override_dh_auto_install:
@@ -168,13 +194,28 @@
 			$(CURDIR)/debian/qemu-user-static/usr/share/binfmts ; \
 	done
 	f=debian/qemu-user-static.sysctl; [ -f debian/qemu-user-static.sysctl.$(DEB_BUILD_ARCH) ] && f=debian/qemu-user-static.sysctl.$(DEB_BUILD_ARCH); cp $$f debian/qemu-user-static/etc/sysctl.d/30-qemu-user-static.conf
+ifeq ($(DEB_HOST_ARCH),amd64)
+	dh_auto_install -B spice-build --destdir=$(CURDIR)/debian/spice-tmp
+	for target in qemu-i386 qemu-x86_64 qemu-system-x86_64; do \
+		mv $(CURDIR)/debian/spice-tmp/usr/bin/$$target \
+			$(CURDIR)/debian/spice-tmp/usr/bin/$$target-spice; \
+	done
+	mv $(CURDIR)/debian/spice-tmp/usr/bin/qemu-system-i386 \
+	   $(CURDIR)/debian/spice-tmp/usr/bin/qemu-spice
+endif
 endif
 	dh_auto_install -B system-build --destdir=$(CURDIR)/debian/tmp
 	mv $(CURDIR)/debian/tmp/usr/share/man/man1/qemu.1 \
 	   $(CURDIR)/debian/tmp/usr/share/man/man1/qemu-system.1
 
+override_dh_install:
+ifeq ($(DEB_HOST_ARCH),amd64)
+	dh_install -pqemu-kvm-spice --sourcedir=$(CURDIR)/debian/spice-tmp
+endif
+	dh_install -Nqemu-kvm-spice
+
 override_dh_auto_clean:
-	rm -rf user-static-build user-build system-build
+	rm -rf user-static-build user-build system-build spice-build
 
 override_dh_auto_test:
 	# tests are broken ATM
